import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGoodsImage, ThinkGoodsImageParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkGoodsImage(params: ThinkGoodsImageParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGoodsImage>>>(
    THINK_API_URL + '/think/think-goods-image/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkGoodsImage(params?: ThinkGoodsImageParam) {
  const res = await request.get<ApiResult<ThinkGoodsImage[]>>(
    THINK_API_URL + '/think/think-goods-image',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkGoodsImage(data: ThinkGoodsImage) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-image',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkGoodsImage(data: ThinkGoodsImage) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-image',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkGoodsImage(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-image/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkGoodsImage(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-image/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkGoodsImage(id: number) {
  const res = await request.get<ApiResult<ThinkGoodsImage>>(
    THINK_API_URL + '/think/think-goods-image/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
